# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
RandomFeatureSelector
"""

__all__ = ["RandomFeatureSelector"]


from ...internal.core.ensemble.feature_selector.randomfeatureselector import \
    RandomFeatureSelector as core
from ...internal.utils.utils import trace


class RandomFeatureSelector(core):
    """
    **Description**
        Selects a random subset of features for each trainer in the ensemble

    :param features_selection_proportion: The proportion of features to be
        selected. The range is 0.0-1.0.

    :param params: Additional arguments sent to compute engine.

    """

    @trace
    def __init__(
            self,
            features_selection_proportion=0.8,
            **params):
        core.__init__(
            self,
            features_selection_proportion=features_selection_proportion,
            **params)

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
