# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
ClassifierAverage
"""

__all__ = ["ClassifierAverage"]


from ...internal.core.ensemble.output_combiner.classifieraverage import \
    ClassifierAverage as core
from ...internal.utils.utils import trace


class ClassifierAverage(core):
    """
    **Description**
        Computes the average of the outputs of the trained models

    :param normalize: Whether to normalize the output of base models before
        combining them.

    :param params: Additional arguments sent to compute engine.

    """

    @trace
    def __init__(
            self,
            normalize=True,
            **params):
        core.__init__(
            self,
            normalize=normalize,
            **params)

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
