# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
CustomStopWordsRemover
"""

__all__ = ["CustomStopWordsRemover"]

from \
    ....internal.core.feature_extraction.text.stopwords.customstopwordsremover \
    import CustomStopWordsRemover as core
from ....internal.utils.utils import trace


class CustomStopWordsRemover(core):
    """

    Remover with list of stopwords specified by the user.

    .. remarks::
        The :py:class:`NGramFeaturizer
        <nimbusml.feature_extraction.text.NGramFeaturizer>` transform produces a
        bag of counts of
        sequences of consecutive words from a given corpus of text.
        It also offers stopwords removing. A user-defined list of stopwords.
        It accepts the following option: ``stopword``.

    :param stopword: List of stopwords.

    :param params: Additional arguments sent to compute engine.

    .. seealso::
        :py:class:`NGramFeaturizer
        <nimbusml.feature_extraction.text.NGramFeaturizer>`,
        :py:class:`PredefinedStopWordsRemover
        <nimbusml.feature_extraction.text.stopwords.PredefinedStopWordsRemover>`,

    .. index:: transform, featurizer, text

    Example:
       .. literalinclude:: /../nimbusml/examples/NGramFeaturizer2.py
              :language: python
    """

    @trace
    def __init__(
            self,
            stopword=None,
            **params):
        core.__init__(
            self,
            stopword=stopword,
            **params)

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
