# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
PredefinedStopWordsRemover
"""

__all__ = ["PredefinedStopWordsRemover"]


from .....utils.entrypoints import Component
from .....utils.utils import trace


class PredefinedStopWordsRemover(Component):
    """

    Remover with predefined list of stop words.

    .. remarks::
        The :py:class:`NGramFeaturizer
        <nimbusml.feature_extraction.text.NGramFeaturizer>` transform produces a
        bag of counts of
        sequences of consecutive words from a given corpus of text.
        It also offers stopwords removing. A precompiled language-specific
        lists of stop words is used in this class that includes the most
        common words from Microsoft Office.

    :param params: Additional arguments sent to compute engine.

    .. seealso::
        :py:class:`NGramFeaturizer
        <nimbusml.feature_extraction.text.NGramFeaturizer>`,
        :py:class:`CustomStopWordsRemover
        <nimbusml.feature_extraction.text.stopwords.CustomStopWordsRemover>`,

    .. index:: transform, featurizer, text

    Example:
       .. literalinclude:: /../nimbusml/examples/NGramFeaturizer.py
              :language: python
    """

    @trace
    def __init__(
            self,
            **params):

        self.kind = 'StopWordsRemover'
        self.name = 'Predefined'
        self.settings = {}

        super(
            PredefinedStopWordsRemover,
            self).__init__(
            name=self.name,
            settings=self.settings,
            kind=self.kind)
