# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
SkipFilter
"""

__all__ = ["SkipFilter"]


from ....entrypoints.transforms_rowskipfilter import transforms_rowskipfilter
from ....utils.utils import trace
from ...base_pipeline_item import BasePipelineItem, NoOutputSignature


class SkipFilter(BasePipelineItem, NoOutputSignature):
    """

    Skip the first N rows of the dataset, allowing limiting input to a
    subset of rows.

    :param count: number of rows to skip from the beginning of the dataset.

    :param params: Additional arguments sent to compute engine.

    .. index:: transform, random

    Example:
       .. literalinclude:: /../nimbusml/examples/SkipFilter.py
              :language: python
    """

    @trace
    def __init__(
            self,
            count=0,
            **params):
        BasePipelineItem.__init__(
            self, type='transform', **params)

        self.count = count

    @property
    def _entrypoint(self):
        return transforms_rowskipfilter

    @trace
    def _get_node(self, **all_args):
        algo_args = dict(
            count=self.count)

        all_args.update(algo_args)
        return self._entrypoint(**all_args)
