# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
PQ
"""

import numbers

from ..utils.entrypoints import Component
from ..utils.utils import try_set


def pq(
        threshold=0.01,
        window_size=5,
        **params):
    """
    **Description**
        Stops in case of generality to progress ration exceeds threshold.

    :param threshold: Threshold in range [0,1]. (settings).
    :param window_size: The window size. (settings).
    """

    entrypoint_name = 'PQ'
    settings = {}

    if threshold is not None:
        settings['Threshold'] = try_set(
            obj=threshold,
            none_acceptable=True,
            is_of_type=numbers.Real,
            valid_range={
                'Max': 1.0,
                'Min': 0.0})
    if window_size is not None:
        settings['WindowSize'] = try_set(
            obj=window_size,
            none_acceptable=True,
            is_of_type=numbers.Real, valid_range={'Inf': 0})

    component = Component(
        name=entrypoint_name,
        settings=settings,
        kind='EarlyStoppingCriterion')
    return component
