# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
BestDiverseSelectorMultiClass
"""

import numbers

from ..utils.entrypoints import Component
from ..utils.utils import try_set
from ._ensemblemulticlassdiversitymeasure_multidisagreementdiversitymeasure import \
    multi_disagreement_diversity_measure


def best_diverse_selector_multi_class(
        diversity_metric_type=None,
        learners_selection_proportion=0.5,
        validation_dataset_proportion=0.3,
        **params):
    """
    **Description**
        None

    :param diversity_metric_type: The metric type to be used to find
        the diversity among base learners (settings).
    :param learners_selection_proportion: The proportion of best base
        learners to be selected. The range is 0.0-1.0 (settings).
    :param validation_dataset_proportion: The proportion of instances
        to be selected to test the individual base learner. If it is
        0, it uses training set (settings).
    """

    entrypoint_name = 'BestDiverseSelectorMultiClass'
    settings = {}

    if diversity_metric_type is not None:
        settings['DiversityMetricType'] = try_set(
            obj=diversity_metric_type, none_acceptable=True, is_of_type=dict)
    if learners_selection_proportion is not None:
        settings['LearnersSelectionProportion'] = try_set(
            obj=learners_selection_proportion,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if validation_dataset_proportion is not None:
        settings['ValidationDatasetProportion'] = try_set(
            obj=validation_dataset_proportion,
            none_acceptable=True,
            is_of_type=numbers.Real)

    component = Component(
        name=entrypoint_name,
        settings=settings,
        kind='EnsembleMulticlassSubModelSelector')
    return component
