# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Models.Summarizer
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def models_summarizer(
        predictor_model,
        summary=None,
        stats=None,
        **params):
    """
    **Description**
        Summarize a linear regression predictor.

    :param predictor_model: The predictor to summarize (inputs).
    :param summary: The summary of a predictor (outputs).
    :param stats: The training set statistics. Note that this output
        can be null. (outputs).
    """

    entrypoint_name = 'Models.Summarizer'
    inputs = {}
    outputs = {}

    if predictor_model is not None:
        inputs['PredictorModel'] = try_set(
            obj=predictor_model,
            none_acceptable=False,
            is_of_type=str)
    if summary is not None:
        outputs['Summary'] = try_set(
            obj=summary,
            none_acceptable=False,
            is_of_type=str)
    if stats is not None:
        outputs['Stats'] = try_set(
            obj=stats,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
