# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
TimeSeriesProcessingEntryPoints.SlidingWindowTransform
"""

import numbers

from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def timeseriesprocessingentrypoints_slidingwindowtransform(
        source,
        data,
        name,
        output_data=None,
        model=None,
        window_size=2,
        lag=1,
        begin='NaNValues',
        **params):
    """
    **Description**
        Returns the last values for a time series [y(t-d-l+1), y(t-d-l+2),
        ..., y(t-l-1), y(t-l)] where d is the size of the window, l
        the lag and y is a Float.

    :param source: The name of the source column (inputs).
    :param data: Input dataset (inputs).
    :param name: The name of the new column (inputs).
    :param window_size: The size of the sliding window for computing
        the moving average (inputs).
    :param lag: Lag between current observation and last observation
        from the sliding window (inputs).
    :param begin: Define how to populate the first rows of the
        produced series (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'TimeSeriesProcessingEntryPoints.SlidingWindowTransform'
    inputs = {}
    outputs = {}

    if source is not None:
        inputs['Source'] = try_set(
            obj=source,
            none_acceptable=False,
            is_of_type=str,
            is_column=True)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if name is not None:
        inputs['Name'] = try_set(
            obj=name,
            none_acceptable=False,
            is_of_type=str,
            is_column=True)
    if window_size is not None:
        inputs['WindowSize'] = try_set(
            obj=window_size,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if lag is not None:
        inputs['Lag'] = try_set(
            obj=lag,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if begin is not None:
        inputs['Begin'] = try_set(
            obj=begin,
            none_acceptable=True,
            is_of_type=str,
            values=[
                'NaNValues',
                'FirstValue'])
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
