# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.CombinerByContiguousGroupId
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_combinerbycontiguousgroupid(
        data,
        column,
        output_data=None,
        model=None,
        group_key=None,
        **params):
    """
    **Description**
        Groups values of a scalar column into a vector, by a contiguous group
        ID

    :param group_key: Columns to group by (inputs).
    :param data: Input dataset (inputs).
    :param column: Columns to group together (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.CombinerByContiguousGroupId'
    inputs = {}
    outputs = {}

    if group_key is not None:
        inputs['GroupKey'] = try_set(
            obj=group_key,
            none_acceptable=True,
            is_of_type=list)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=False,
            is_of_type=list,
            is_column=True)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
