# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.DataCache
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_datacache(
        data,
        output_data=None,
        caching='Memory',
        **params):
    """
    **Description**
        Caches using the specified cache option.

    :param data: Input dataset (inputs).
    :param caching: Caching strategy (inputs).
    :param output_data: Dataset (outputs).
    """

    entrypoint_name = 'Transforms.DataCache'
    inputs = {}
    outputs = {}

    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if caching is not None:
        inputs['Caching'] = try_set(
            obj=caching,
            none_acceptable=False,
            is_of_type=str,
            values=[
                'Memory',
                'Disk'])
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
