# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.DatasetTransformScorer
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_datasettransformscorer(
        data,
        transform_model,
        scored_data=None,
        scoring_transform=None,
        **params):
    """
    **Description**
        Score a dataset with a transform model

    :param data: The dataset to be scored (inputs).
    :param transform_model: The transform model to apply to data
        (inputs).
    :param scored_data: The scored dataset (outputs).
    :param scoring_transform: The scoring transform (outputs).
    """

    entrypoint_name = 'Transforms.DatasetTransformScorer'
    inputs = {}
    outputs = {}

    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if transform_model is not None:
        inputs['TransformModel'] = try_set(
            obj=transform_model,
            none_acceptable=False,
            is_of_type=str)
    if scored_data is not None:
        outputs['ScoredData'] = try_set(
            obj=scored_data,
            none_acceptable=False,
            is_of_type=str)
    if scoring_transform is not None:
        outputs['ScoringTransform'] = try_set(
            obj=scoring_transform, none_acceptable=False, is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
