# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.HashConverter
"""

import numbers

from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_hashconverter(
        column,
        data,
        output_data=None,
        model=None,
        number_of_bits=31,
        join=True,
        seed=314489979,
        ordered=True,
        **params):
    """
    **Description**
        Converts column values into hashes. This transform accepts both
        numeric and text inputs, both single and vector-valued
        columns.

    :param column: New column definition(s) (optional form: name:src)
        (inputs).
    :param data: Input dataset (inputs).
    :param number_of_bits: Number of bits to hash into. Must be
        between 1 and 31, inclusive. (inputs).
    :param join: Whether the values need to be combined for a single
        hash (inputs).
    :param seed: Hashing seed (inputs).
    :param ordered: Whether the position of each term should be
        included in the hash (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.HashConverter'
    inputs = {}
    outputs = {}

    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=False,
            is_of_type=list,
            is_column=True)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if number_of_bits is not None:
        inputs['NumberOfBits'] = try_set(
            obj=number_of_bits,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if join is not None:
        inputs['Join'] = try_set(
            obj=join,
            none_acceptable=True,
            is_of_type=bool)
    if seed is not None:
        inputs['Seed'] = try_set(
            obj=seed,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if ordered is not None:
        inputs['Ordered'] = try_set(
            obj=ordered,
            none_acceptable=True,
            is_of_type=bool)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
