# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.LabelColumnKeyBooleanConverter
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_labelcolumnkeybooleanconverter(
        data,
        label_column,
        output_data=None,
        model=None,
        text_key_values=True,
        **params):
    """
    **Description**
        Transforms the label to either key or bool (if needed) to make it
        suitable for classification.

    :param data: Input dataset (inputs).
    :param label_column: The label column (inputs).
    :param text_key_values: Convert the key values to text (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.LabelColumnKeyBooleanConverter'
    inputs = {}
    outputs = {}

    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if label_column is not None:
        inputs['LabelColumn'] = try_set(
            obj=label_column,
            none_acceptable=False,
            is_of_type=str,
            is_column=True)
    if text_key_values is not None:
        inputs['TextKeyValues'] = try_set(
            obj=text_key_values,
            none_acceptable=True,
            is_of_type=bool)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
