# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.ManyHeterogeneousModelCombiner
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_manyheterogeneousmodelcombiner(
        transform_models,
        predictor_model,
        model=None,
        **params):
    """
    **Description**
        Combines a sequence of TransformModels and a PredictorModel into a
        single PredictorModel.

    :param transform_models: Transform model (inputs).
    :param predictor_model: Predictor model (inputs).
    :param predictor_model: Predictor model (outputs).
    """

    entrypoint_name = 'Transforms.ManyHeterogeneousModelCombiner'
    inputs = {}
    outputs = {}

    if transform_models is not None:
        inputs['TransformModels'] = try_set(
            obj=transform_models,
            none_acceptable=False,
            is_of_type=list)
    if predictor_model is not None:
        inputs['PredictorModel'] = try_set(
            obj=predictor_model,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['PredictorModel'] = try_set(
            obj=model, none_acceptable=False, is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
