# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.MissingValueSubstitutor
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_missingvaluesubstitutor(
        column,
        data,
        output_data=None,
        model=None,
        replacement_kind='Default',
        impute_by_slot=True,
        **params):
    """
    **Description**
        Create an output column of the same type and size of the input
        column, where missing values are replaced with either the
        default value or the mean/min/max value (for non-text columns
        only).

    :param column: New column definition(s) (optional form:
        name:rep:src) (inputs).
    :param data: Input dataset (inputs).
    :param replacement_kind: The replacement method to utilize
        (inputs).
    :param impute_by_slot: Whether to impute values by slot (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.MissingValueSubstitutor'
    inputs = {}
    outputs = {}

    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=False,
            is_of_type=list,
            is_column=True)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if replacement_kind is not None:
        inputs['ReplacementKind'] = try_set(
            obj=replacement_kind,
            none_acceptable=True,
            is_of_type=str,
            values=[
                'DefaultValue',
                'Mean',
                'Minimum',
                'Maximum',
                'SpecifiedValue'])
    if impute_by_slot is not None:
        inputs['ImputeBySlot'] = try_set(
            obj=impute_by_slot,
            none_acceptable=True,
            is_of_type=bool)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
