# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.RobustScaler
"""

import numbers

from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_robustscaler(
        column,
        data,
        output_data=None,
        model=None,
        center=True,
        scale=True,
        quantile_min=25.0,
        quantile_max=75.0,
        **params):
    """
    **Description**
        Removes the median and scales the data according to the quantile
        range.

    :param column: New column definition (optional form: name:src)
        (inputs).
    :param data: Input dataset (inputs).
    :param center: If True, center the data before scaling. (inputs).
    :param scale: If True, scale the data to interquartile range.
        (inputs).
    :param quantile_min: Min for the quantile range used to calculate
        scale. (inputs).
    :param quantile_max: Max for the quantile range used to calculate
        scale. (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.RobustScaler'
    inputs = {}
    outputs = {}

    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=False,
            is_of_type=list,
            is_column=True)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if center is not None:
        inputs['Center'] = try_set(
            obj=center,
            none_acceptable=True,
            is_of_type=bool)
    if scale is not None:
        inputs['Scale'] = try_set(
            obj=scale,
            none_acceptable=True,
            is_of_type=bool)
    if quantile_min is not None:
        inputs['QuantileMin'] = try_set(
            obj=quantile_min,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if quantile_max is not None:
        inputs['QuantileMax'] = try_set(
            obj=quantile_max,
            none_acceptable=True,
            is_of_type=numbers.Real)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
