# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.ScoreColumnSelector
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_scorecolumnselector(
        data,
        output_data=None,
        model=None,
        extra_columns=None,
        **params):
    """
    **Description**
        Selects only the last score columns and the extra columns specified
        in the arguments.

    :param data: Input dataset (inputs).
    :param extra_columns: Extra columns to write (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.ScoreColumnSelector'
    inputs = {}
    outputs = {}

    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if extra_columns is not None:
        inputs['ExtraColumns'] = try_set(
            obj=extra_columns,
            none_acceptable=True,
            is_of_type=list,
            is_column=True)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
