# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.WordEmbeddings
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_wordembeddings(
        column,
        data,
        output_data=None,
        model=None,
        model_kind='SentimentSpecificWordEmbedding',
        custom_lookup_table=None,
        **params):
    """
    **Description**
        Word Embeddings transform is a text featurizer which converts vectors
        of text tokens into sentence vectors using a pre-trained
        model

    :param column: New column definition(s) (optional form: name:src)
        (inputs).
    :param model_kind: Pre-trained model used to create the
        vocabulary (inputs).
    :param data: Input dataset (inputs).
    :param custom_lookup_table: Filename for custom word embedding
        model (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.WordEmbeddings'
    inputs = {}
    outputs = {}

    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=False,
            is_of_type=list,
            is_column=True)
    if model_kind is not None:
        inputs['ModelKind'] = try_set(
            obj=model_kind,
            none_acceptable=True,
            is_of_type=str,
            values=[
                'GloVe50D',
                'GloVe100D',
                'GloVe200D',
                'GloVe300D',
                'GloVeTwitter25D',
                'GloVeTwitter50D',
                'GloVeTwitter100D',
                'GloVeTwitter200D',
                'FastTextWikipedia300D',
                'SentimentSpecificWordEmbedding'])
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if custom_lookup_table is not None:
        inputs['CustomLookupTable'] = try_set(
            obj=custom_lookup_table, none_acceptable=True, is_of_type=str)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
