# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
Transforms.WordTokenizer
"""


from ..utils.entrypoints import EntryPoint
from ..utils.utils import try_set, unlist


def transforms_wordtokenizer(
        data,
        output_data=None,
        model=None,
        column=None,
        char_array_term_separators=None,
        **params):
    """
    **Description**
        The input to this transform is text, and the output is a vector of
        text containing the words (tokens) in the original text. The
        separator is space, but can be specified as any other
        character (or multiple characters) if needed.

    :param column: New column definition(s) (inputs).
    :param data: Input dataset (inputs).
    :param char_array_term_separators: Array of single character term
        separator(s). By default uses space character separator.
        (inputs).
    :param output_data: Transformed dataset (outputs).
    :param model: Transform model (outputs).
    """

    entrypoint_name = 'Transforms.WordTokenizer'
    inputs = {}
    outputs = {}

    if column is not None:
        inputs['Column'] = try_set(
            obj=column,
            none_acceptable=True,
            is_of_type=list,
            is_column=True)
    if data is not None:
        inputs['Data'] = try_set(
            obj=data,
            none_acceptable=False,
            is_of_type=str)
    if char_array_term_separators is not None:
        inputs['CharArrayTermSeparators'] = try_set(
            obj=char_array_term_separators,
            none_acceptable=True,
            is_of_type=list)
    if output_data is not None:
        outputs['OutputData'] = try_set(
            obj=output_data,
            none_acceptable=False,
            is_of_type=str)
    if model is not None:
        outputs['Model'] = try_set(
            obj=model,
            none_acceptable=False,
            is_of_type=str)

    input_variables = {
        x for x in unlist(inputs.values())
        if isinstance(x, str) and x.startswith("$")}
    output_variables = {
        x for x in unlist(outputs.values())
        if isinstance(x, str) and x.startswith("$")}

    entrypoint = EntryPoint(
        name=entrypoint_name, inputs=inputs, outputs=outputs,
        input_variables=input_variables,
        output_variables=output_variables)
    return entrypoint
