# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
DatasetTransformer
"""

__all__ = ["DatasetTransformer"]


from sklearn.base import TransformerMixin

from ..base_transform import BaseTransform
from ..internal.core.preprocessing.datasettransformer import \
    DatasetTransformer as core
from ..internal.utils.utils import trace


class DatasetTransformer(core, BaseTransform, TransformerMixin):
    """
    **Description**
        Applies a TransformModel to a dataset.

    :param columns: see `Columns </nimbusml/concepts/columns>`_.

    :param transform_model: Transform model.

    :param params: Additional arguments sent to compute engine.

    """

    @trace
    def __init__(
            self,
            transform_model,
            columns=None,
            **params):

        if columns:
            params['columns'] = columns
        BaseTransform.__init__(self, **params)
        core.__init__(
            self,
            transform_model=transform_model,
            **params)
        self._columns = columns

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
