# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
DateTimeSplitter
"""

__all__ = ["DateTimeSplitter"]


from sklearn.base import TransformerMixin

from ..base_transform import BaseTransform
from ..internal.core.preprocessing.datetimesplitter import \
    DateTimeSplitter as core
from ..internal.utils.utils import trace


class DateTimeSplitter(core, BaseTransform, TransformerMixin):
    """
    **Description**
        Splits a date time value into each individual component

    :param columns: see `Columns </nimbusml/concepts/columns>`_.

    :param prefix: Output column prefix.

    :param country: Country to get holidays for. Defaults to none if not
        passed.

    :param params: Additional arguments sent to compute engine.

    """

    @trace
    def __init__(
            self,
            prefix,
            country='None',
            columns=None,
            **params):

        if columns:
            params['columns'] = columns
        BaseTransform.__init__(self, **params)
        core.__init__(
            self,
            prefix=prefix,
            country=country,
            **params)
        self._columns = columns

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
