# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.
# --------------------------------------------------------------------------------------------
# - Generated by tools/entrypoint_compiler.py: do not edit by hand
"""
ToKeyImputer
"""

__all__ = ["ToKeyImputer"]


from sklearn.base import TransformerMixin

from ..base_transform import BaseTransform
from ..internal.core.preprocessing.tokeyimputer import ToKeyImputer as core
from ..internal.utils.utils import trace


class ToKeyImputer(core, BaseTransform, TransformerMixin):
    """
    **Description**
        Fills in missing values in a column based on the most frequent value

    :param columns: see `Columns </nimbusml/concepts/columns>`_.

    :param params: Additional arguments sent to compute engine.

    """

    @trace
    def __init__(
            self,
            columns=None,
            **params):

        if columns:
            params['columns'] = columns
        BaseTransform.__init__(self, **params)
        core.__init__(
            self,
            **params)
        self._columns = columns

    def get_params(self, deep=False):
        """
        Get the parameters for this operator.
        """
        return core.get_params(self)
